%define _logdir /var/log

#set default build options
# disabled as overrides xv
%define build_directfb		0
%define build_firewire		1
%define build_dts		1
%define build_faac		0
%define build_faad		1
%define build_lame		1

%{?_without_directfb:		%global build_directfb 0}
%{?_without_dts:		%global build_dts 0}
%{?_without_faac:		%global build_faac 0}
%{?_without_faad:		%global build_faad 0}
%{?_without_firewire:		%global build_firewire 0}
%{?_without_lame:		%global build_lame 0}

%{?_with_directfb:		%global build_directfb 1}
%{?_with_dts:			%global build_dts 1}
%{?_with_faac:			%global build_faac 1}
%{?_with_faad:			%global build_faad 1}
%{?_with_firewire:		%global build_firewire 1}
%{?_with_lame:			%global build_lame 1}

Summary: A personal video recorder (PVR) application
Name: mythtv
Version: 0.21.0
Release: alt1.svn19253
Url: http://www.mythtv.org/
License: GPL
Group: Video
Source0: %name-%version.tar
Source1: mythbackend.init
Source2: mythbackend.logrotate
Source3: 99MythFrontend
Patch0: mythtv-%version-%release.patch

%set_verify_elf_method textrel=relaxed

%set_perl_req_method relaxed


BuildRequires: gcc-c++ libalsa-devel libdca-devel libfaac-devel ImageMagick
BuildRequires: libfaad-devel liblame-devel liblirc-devel libmesa-devel libqt3-devel 
BuildRequires: libXinerama-devel libXrandr-devel libxvid-devel libXvMC-devel
BuildRequires: perl-DBI perl-devel libtheora-devel libx264-devel libvorbis-devel
BuildRequires: perl-MIME-tools perl-Net-Server perl-Date-Calc perl-libwww perl-Net-UPnP
BuildRequires: python-dev

%description
MythTV implements the following PVR features, and more, with a
unified graphical interface:

 - Basic 'live-tv' functionality. Pause/Fast Forward/Rewind "live" TV.
 - Video compression using RTjpeg or MPEG-4
 - Program listing retrieval using XMLTV
 - Themable, semi-transparent on-screen display
 - Electronic program guide
 - Scheduled recording of TV programs
 - Resolution of conflicts between scheduled recordings
 - Basic video editing

This package is in PLF because it contains software that supports
codecs that may be covered by software patents.

%package -n lib%name
Summary: Library providing mythtv support
Group: System/Libraries
Provides: lib%name = %version-%release
Provides: mythtv-frontend-api = %(echo %version | awk -F. '{print $1 "." $2}')

%description -n lib%name
Common library code for MythTV and add-on modules (development)
MythTV provides a unified graphical interface for recording and viewing
television programs.

This package is in PLF because it contains software that supports
codecs that may be covered by software patents.

%package -n lib%name-devel
Summary: Development files for libmyth
Group: Development/Other
Requires: lib%name = %version-%release
Provides: lib%name-devel = %version-%release
Provides: myth-devel = %version-%release

%description -n lib%name-devel
This package contains the header files and libraries for developing
add-ons for mythtv.

This package is in PLF because it contains software that supports
codecs that may be covered by software patents.

%package themes-base
Summary: Base themes for mythtv's frontend
Group: Video

%description themes-base
MythTV provides a unified graphical interface for recording and viewing
television programs.

This package contains only the base themes used by mythtv-frontend and
mythtv-setup.

%package frontend
Summary: Client component of mythtv (a PVR)
Group: Video
Requires: mythtv-themes-base = %version-%release
Requires: libqt3-mysql fonts-ttf-dejavu

%description frontend
MythTV provides a unified graphical interface for recording and viewing
television programs.

This package contains only the client software, which provides a
front-end for playback and configuration.  It requires access to a
mythtv-backend installation, either on the same system or one
reachable via the network.

This package is in PLF because it contains software that supports
codecs that may be covered by software patents.

%package backend
Summary: Server component of mythtv (a PVR)
Group: Video
Requires: lib%name = %version-%release
Requires: libqt3-mysql

%description backend
MythTV provides a unified graphical interface for recording and viewing
television programs.

This package contains only the server software, which provides video
and audio capture and encoding services.  In order to be useful, it
requires a mythtv-frontend installation, either on the same system or
one reachable via the network.

This package is in PLF because it contains software that supports
codecs that may be covered by software patents.

%package setup
Summary: Setup the mythtv backend
Group: Video
Requires: mythtv-backend = %version-%release
Requires: mythtv-themes-base = %version-%release
Provides: mythtvsetup
Requires: libqt3-mysql

%description setup
MythTV provides a unified graphical interface for recording and viewing
television programs.

This package contains the setup software for configuring the mythtv
backend.
This package is in PLF because it contains software that supports
codecs that may be covered by software patents.

%package doc
Summary: MythTV documentation
Group: Video
Obsoletes: mythtv < 0.20-5

%description doc
MythTV provides a unified graphical interface for recording and viewing
television programs.

This package contains the documentation and contributed additional
scripts for MythTV.

%package -n perl-MythTV
Summary:        Perl bindings for MythTV
Group:          Development/Perl

%description -n perl-MythTV
MythTV provides a unified graphical interface for recording and viewing
television programs.
        
This package contains the perl bindings for MythTV.

%prep
%setup -q
%patch0 -p1

# (anssi) As of 0.20, only documentation and contrib scripts are affected.
find . -type f | xargs grep -l /usr/local | xargs perl -pi -e's|/usr/local|%prefix|g'

#echo "QMAKE_PROJECT_DEPTH = 0" >> mythtv.pro
#echo "QMAKE_PROJECT_DEPTH = 0" >> settings.pro

# default recordings dir
perl -pi -e's|/mnt/store|%_localstatedir/mythtv/recordings|' programs/mythtv-setup/backendsettings.cpp

# do not set hardcoded archflags
perl -pi -e's|^echo "ARCHFLAGS=|# echo "ARCHFLAGS=|' configure

%build
export QTDIR=%_qt3dir
export QTLIB=%_qt3dir/%_lib
#export CFLAGS="%optflags"
#export CXXFLAGS="%optflags"

./configure --prefix=%prefix \
	--libdir-name=%_lib \
	--enable-dvb \
%ifarch %ix86
	--cpu=pentium3 \
%endif
	--enable-small \
	--disable-audio-oss \
	--disable-audio-arts \
	--enable-opengl-vsync \
	--enable-xvmc --enable-xvmc-pro \
	--without-bindings=perl \
	--without-bindings=python \
	--enable-libtheora \
	--enable-libvorbis \
	--enable-pthreads \
	--enable-libx264 \
	--enable-libxvid \
%if %build_faac
	--enable-faac \
%endif
%if %build_faad
	--enable-libfaad \
%endif
%if %build_directfb
	--enable-directfb \
%endif
%if !%build_firewire
	--disable-firewire \
%else
	--enable-firewire \
%endif
%if !%build_lame
	--disable-lame
%endif

%make_build 
#hack for circular dependicy
subst "s,^\#LIBS,LIBS,m" libs/libmythui/libmythui.pro libs/libmythupnp/libmythupnp.pro
rm -f libs/libmythui/libmythui*.so* libs/libmythupnp/libmythupnp*.so*
rm -f libs/libmythui/Makefile libs/libmythupnp/Makefile
%make_build QMAKE=%_bindir/qmake-qt3

pushd bindings/perl
%perl_vendor_build
popd

pushd i18n
lrelease-qt3 mythfrontend_ru.ts
popd


%install

INSTALL_ROOT=%buildroot; export INSTALL_ROOT
%makeinstall QMAKE=qmake-qt3

mkdir -p %buildroot%_localstatedir/mythtv
mkdir -p %buildroot%_localstatedir/mythtv/recordings
mkdir -p %buildroot%_var/cache/mythtv
mkdir -p %buildroot%_logdir/mythtv
mkdir -p %buildroot%_sysconfdir/logrotate.d
mkdir -p %buildroot%_initdir

install -p %SOURCE1 %buildroot%_initdir/mythbackend
install -p %SOURCE2  %buildroot%_sysconfdir/logrotate.d

# wmsession.d for mythfrontend
mkdir -p %buildroot%_sysconfdir/X11/wmsession.d
install -p %SOURCE3 %buildroot%_sysconfdir/X11/wmsession.d

# icon
mkdir -p %buildroot/{%_miconsdir,%_iconsdir,%_liconsdir}
convert themes/G.A.N.T/watermark/tv.png -resize 16x16 %buildroot/%_miconsdir/%name.png
convert themes/G.A.N.T/watermark/tv.png -resize 32x32 %buildroot/%_iconsdir/%name.png
convert themes/G.A.N.T/watermark/tv.png -resize 48x48 %buildroot/%_liconsdir/%name.png

install -d -m755 %buildroot%_datadir/applications
cat <<EOF > %buildroot%_datadir/applications/mythtv-frontend.desktop
[Desktop Entry]
Name=MythTV
Comment=Record, playback and watch TV
Exec=%_bindir/mythfrontend
Icon=%name
Terminal=false
Type=Application
Categories=Qt;AudioVideo;Video;TV;Recorder
EOF
cat <<EOF > %buildroot%_datadir/applications/mythtv-setup.desktop
[Desktop Entry]
Name=MythTV Setup
Comment=Setup MythTV backend
Exec=%_bindir/mythtv-setup
Icon=%name
Terminal=false
Type=Application
Categories=Qt;AudioVideo;Video;TV;Recorder
EOF

cat > README.install <<EOF
You can import the initial database by running:
mysql -u root -p < %_datadir/mythtv/initialdb/mc.sql
(you can omit -p if you do not have the password set)
EOF

mkdir -p %buildroot%_libdir/mythtv/plugins

install -d -m755 %buildroot%_datadir/mythtv/initialdb
install -m644 database/* %buildroot%_datadir/mythtv/initialdb

# install a few useful contrib scripts
install -m755 contrib/mythrename.pl %buildroot%_bindir
install -m755 contrib/mythname.pl %buildroot%_bindir
install -m755 contrib/optimize_mythdb.pl %buildroot%_bindir

mkdir -p %buildroot%_sysconfdir/sysconfig/
touch  %buildroot%_sysconfdir/sysconfig/mythbackend

pushd bindings/perl
%perl_vendor_install
popd

%pre backend
# Add the "_mythtv" user
groupadd _mythtv
/usr/sbin/useradd -r -g _mythtv -G radio,audio,video -d %_localstatedir/mythtv -s /dev/null -n _mythtv >/dev/null 2>&1 ||:

%files doc
%doc README UPGRADING AUTHORS COPYING FAQ
%doc keys.txt
%doc docs/*.html docs/*.png docs/*.txt docs/i18n contrib

%files backend
%_bindir/mythbackend
%_bindir/mythfilldatabase
%_bindir/mythjobqueue
%_bindir/mythname.pl
%_bindir/mythrename.pl
%_bindir/optimize_mythdb.pl
%config(noreplace) %_sysconfdir/sysconfig/mythbackend
%attr(-,_mythtv,_mythtv) %dir %_localstatedir/mythtv
%attr(-,_mythtv,_mythtv) %dir %_localstatedir/mythtv/recordings
%attr(-,_mythtv,_mythtv) %dir %_var/cache/mythtv
%_initdir/mythbackend
%config(noreplace) %_sysconfdir/logrotate.d/*
%attr(-,_mythtv,_mythtv) %dir %_logdir/mythtv
%dir %_datadir/%name
%dir %_datadir/%name/initialdb
%_datadir/%name/initialdb/mc.sql

%files frontend
%config(noreplace) %_sysconfdir/X11/wmsession.d/99MythFrontend
%_datadir/mythtv/*.xml
%exclude %_datadir/mythtv/setup.xml
%_bindir/mythwelcome
%_bindir/mythfrontend
%_bindir/mythtv
%_bindir/mythcommflag
%_bindir/mythlcdserver
%_bindir/mythtranscode
%_bindir/mythtvosd
%_bindir/mythreplex
%_bindir/mythshutdown
%dir %_libdir/mythtv
%_libdir/mythtv/filters
%_libdir/mythtv/plugins
%dir %_datadir/mythtv
%_datadir/mythtv/*.ttf
%_datadir/mythtv/i18n
%_datadir/applications/mythtv-frontend.desktop

%files setup
%_bindir/mythtv-setup
%_datadir/applications/mythtv-setup.desktop
%dir %_datadir/mythtv
%_datadir/mythtv/setup.xml

%files themes-base
%dir %_datadir/mythtv
%_datadir/mythtv/themes
%_iconsdir/%name.png
%_miconsdir/%name.png
%_liconsdir/%name.png

%files -n lib%name
%_libdir/*.so.*

%files -n lib%name-devel
%_includedir/mythtv
%_libdir/*.so
%_libdir/*.a

%files -n perl-MythTV
%perl_vendor_privlib/MythTV*
%perl_vendor_privlib/IO

%changelog
* Wed Dec 10 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn19253
- new snapshot from mythtv-0-21-fixes branch  
- post-scripts removed (obsoleted by file-triggers)

* Wed May 14 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn17305
- new snapshot from mythtv-0-21-fixes branch 

* Tue May 06 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn17256
- new snapshot from mythtv-0-21-fixes branch 

* Tue Apr 22 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn17100
- new snapshot from mythtv-0-21-fixes branch

* Thu Apr 10 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn17011
- new snapshot from mythtv-0-21-fixes branch

* Wed Apr 02 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn16875
- new snapshot from mythtv release-0-21-fixes branch

* Thu Mar 20 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn16658
- new snapshot

* Tue Feb 26 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn16260
- new snapshot

* Fri Feb 22 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn16196
- new snapshot

* Wed Feb 20 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn16178
- new snapshot

* Mon Feb 18 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn16133
- new snapshot
- added fonts-ttf-dejavu to frontend requires

* Fri Feb 15 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn16032
- new snapshot

* Thu Feb 14 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn16007
- new snapshot

* Fri Feb 08 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15838
- new snapshot

* Wed Feb 06 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15814
- new snapshot 
- updated Russian translation

* Tue Feb 05 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15778
- new snapshot 
- updated Russian translation

* Sun Jan 27 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15617
- new snapshot

* Sat Jan 26 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15596
- new snapshot

* Fri Jan 25 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15577
- new snapshot

* Mon Jan 14 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15438
- new snapshot

* Thu Jan 10 2008 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15405
- new snapshot

* Thu Dec 20 2007 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15198
- new snapshot

* Mon Dec 17 2007 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15177
- new snapshot

* Thu Dec 06 2007 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15072
- new snapshot
- fixed build on x86

* Wed Dec 05 2007 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15059
- new snapshot

* Fri Nov 30 2007 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn15004
- new snapshot

* Thu Nov 29 2007 Anton Farygin <rider@altlinux.ru> 0.21.0-alt1.svn14982
- new snapshot

* Tue Nov 27 2007 Anton Farygin <rider@altlinux.ru> 0.21.0-alt0.svn20071127
- new snapshot

* Wed Nov 21 2007 Anton Farygin <rider@altlinux.ru> 0.21.0-alt0.svn20071121
- new snapshot

* Tue Nov 20 2007 Anton Farygin <rider@altlinux.ru> 0.21.0-alt0.svn20071120
- updated from mainstream svn

* Mon Nov 19 2007 Anton Farygin <rider@altlinux.ru> 0.21.0-alt0.svn20071119
- updated from mainstream svn
- enabled theora and x264 support
- added perl-MythTV subpackage

* Fri Nov 16 2007 Anton Farygin <rider@altlinux.ru> 0.21.0-alt0.svn20071113
- new version, build from svn

* Thu Oct 25 2007 Anton Farygin <rider@altlinux.ru> 0.20.2-alt1
- first build for Sisyphus, based on Mandriva specfile


